<?php
require_once 'listing006.php';
/**
 * Klasse fr ein Cabrio
 * 
 * Es knnen zwar Unterklassen gebildet werden,
 * aber die Methode stopEngine() darf nicht berschrieben
 * werden, da das Dach immer vorher geschlossen werden soll.
 */
class Convertible extends Car {
    /**
     * Gibt an, ob das Dach gerade offen ist
     *
     * @var boolean
     */
    public $roofOpen = false;

    /**
     * ffnet das Dach des Cabrios
     */
    public function openRoof() {
        $this->roofOpen = true;
    }

    /**
     * Schliet das Dach des Cabrios
     */
    public function closeRoof() {
        $this->roofOpen = false;
    }

    /**
     * Motor abstellen.
     * 
     * berschreibt die Implementierung aus der Klasse 'Car'.
     */
    final public function stopEngine() {
        // Falls das Dach offen ist, dieses zuerst schlieen
        if ($this->roofOpen) {
        	$this->closeRoof();
        }
        // Den Motor mit der Implementierung
        // in der Klasse Car stoppen.
        parent::stopEngine();
    }
}
?>