<?php
/**
 * Reprsentation eines Flugzeuges
 */
class Airplane {

    /**
     * Hersteller des Autos
     *
     * @var string
     */
    protected $manufacturer;
    
    /**
     * Aktuelle Flughhe
     *
     * @var integer
     */
    protected $altitude = 0;

    /**
     * Kilometerstand des Flugzeuges
     *
     * @var integer
     */
    protected $milage = 0;
    
    /**
     * Gibt an, ob der Motor schon gestartet wurde
     *
     * @var boolean
     */
    protected $engineStarted = false;

    /**
     * Konstruktor fr ein neues Flugzeug
     *
     * @param string $manufacturer
     */
    public function __construct($manufacturer) {
        $this->manufacturer = $manufacturer;
    }

    /**
     * Motor anlassen
     */
    public function startEngine() {
        $this->engineStarted = true;
    }
    
    /**
     * Abheben
     * 
     * @param integer $feet     Flughhe
     */
    public function takeOff($feet = 5000) {
        // Wenn der Motor nicht luft, kann nicht gestartet werden.
        if ($this->engineStarted !== true) {
        	$this->startEngine();
        }
        $this->altitude = $feet;
    }

    /**
     * Vorwrts fliegen
     *
     * @param integer $miles
     */
    public function flyForward($miles) {
        // Wenn das Flugzeug nicht in der Luft ist, kann nicht geflogen werden.
        if ($this->altitude <= 0) {
        	$this->takeOff();
        }
        $this->milage = $this->milage + $miles;
    }
    
    /**
     * Landen des Flugzeuges
     */
    public function land() {
        $this->altitude = 0;
    }

    /**
     * Motor wieder stoppen
     */
    public function stopEngine() {
        //  Den Motor nicht in der Luft abschalten
        if ($this->altitude > 0) {
        	$this->land();
        }
        $this->engineStarted = false;
    }
    
    /**
     * Destructor eines Flugzeuges
     */
    public function __destruct() {
        $this->land();
        $this->stopEngine();
    }
    
    /**
     * Kilometerstand zurck geben
     *
     * @return integer
     */
    public function getMilage() {
        return $this->milage;
    }
}
?>